//+------------------------------------------------------------------+
//|                                                   RGB-system.mq4 |
//|                                                    Strukov Roman |
//|                                                   srb-78@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Strukov Roman"
#property link      "srb-78@mail.ru"


#property indicator_separate_window
#property  indicator_buffers 8
#property  indicator_color1  Red
#property  indicator_color2  Green
#property  indicator_color3  Blue
#property  indicator_color4  Black

extern int Period_MA  = 900;
extern int Period_RGB = 21; 
extern int History    = 5000;

double GBP[],EUR[],JPY[],USD[],GBP1[],EUR1[],JPY1[],USD1[]; 

int init()
  {
   IndicatorBuffers (8);
   SetIndexBuffer(0, GBP);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(1, EUR);    
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(2, JPY);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(3, USD);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,2);
   SetIndexBuffer(4, USD1);
   SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(5, EUR1);
   SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(6, GBP1);
   SetIndexStyle(6,DRAW_NONE);
   SetIndexBuffer(7, JPY1);
   SetIndexStyle(7,DRAW_NONE);
   IndicatorShortName("RGB system");
   return;
  }
int start()
  {
  int i, Counted_bars;
      Counted_bars = IndicatorCounted(); 
      i = Bars-Counted_bars-1; 
      if (i>History-1) i=History-1;      
 
  while(i>=0) 
    {
     USD1[i] = -(iClose("EURUSD",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i))-
                (iClose("GBPUSD",NULL,i)-iMA("GBPUSD",NULL,Period_MA,0,1,0,i))+
                (iClose("USDJPY",NULL,i)-iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i);
     EUR1[i] =  (iClose("EURUSD",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i))+
                (iClose("EURUSD",NULL,i)*iClose("USDJPY",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i)*iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i)+
                (iClose("EURUSD",NULL,i)/iClose("GBPUSD",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i)/iMA("GBPUSD",NULL,Period_MA,0,1,0,i))*iClose("GBPUSD",NULL,i);
     GBP1[i] =  (iClose("GBPUSD",NULL,i)-iMA("GBPUSD",NULL,Period_MA,0,1,0,i))+
                (iClose("GBPUSD",NULL,i)*iClose("USDJPY",NULL,i)-iMA("GBPUSD",NULL,Period_MA,0,1,0,i)*iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i)-
                (iClose("EURUSD",NULL,i)/iClose("GBPUSD",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i)/iMA("GBPUSD",NULL,Period_MA,0,1,0,i))*iClose("GBPUSD",NULL,i);
     JPY1[i] = -(iClose("USDJPY",NULL,i)-iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i)-
                (iClose("EURUSD",NULL,i)*iClose("USDJPY",NULL,i)-iMA("EURUSD",NULL,Period_MA,0,1,0,i)*iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i)-
                (iClose("GBPUSD",NULL,i)*iClose("USDJPY",NULL,i)-iMA("GBPUSD",NULL,Period_MA,0,1,0,i)*iMA("USDJPY",NULL,Period_MA,0,1,0,i))/iClose("USDJPY",NULL,i);
     i--;
    }
   
   Counted_bars=IndicatorCounted();
   if (Counted_bars>0) Counted_bars--;
   int limit=Bars-Counted_bars;
   for(i=0; i<limit; i++)
    {  
      USD[i]=iMAOnArray(USD1,Bars,Period_RGB,0,MODE_LWMA,i);
      EUR[i]=iMAOnArray(EUR1,Bars,Period_RGB,0,MODE_LWMA,i);
      GBP[i]=iMAOnArray(GBP1,Bars,Period_RGB,0,MODE_LWMA,i);
      JPY[i]=iMAOnArray(JPY1,Bars,Period_RGB,0,MODE_LWMA,i);
    } 
   return;
  }

